<?php
namespace JHodges\PHPUnitBase;

/**
* Set up the Selenium test using args from environment
* Take a screenshot on failed test
**/

abstract class BrowserTest extends \PHPUnit_Extensions_Selenium2TestCase{

  public function setUp(){
    if(! $host=getenv('SeleniumHost')){
      $host='localhost';
    }
    if(! $port=(int)getenv('SeleniumPort')){
      $port=4444;
    }
    if($dcj=getenv('SeleniumDesiredCapabilities')){
        $dc=json_decode($dcj,true);
        if($dc===null){
            throw new \Exception("Invalid JSON: $dcj");
        }
        $this->setDesiredCapabilities($dc);
    }
    $this->setHost($host);
    $this->setPort($port);
    if($url=getenv('SeleniumBrowserUrl')){
        $this->setBrowserUrl($url);
    }
    $this->setBrowser(getenv('SeleniumBrowser'));
  }

  public function tearDown(){
    if ($this->getStatus()!==0) {
      if($path=getenv('SeleniumScreenshotPath')){
        $filedata = $this->currentScreenshot();
        file_put_contents($path.get_class($this).'::'.$this->getName().'.png', $filedata);
      }
    }
    $this->stop();
  }

}
